#ifndef _DIVIDER_CONTROL_H
#define _DIVIDER_CONTROL_H

#include <Control.h>

class BMessageRunner;

namespace BExperimental {

class DividerControl : public BControl
{
public:
	DividerControl(BPoint where, const char* name,
				   BMessage* message,
				   orientation o = B_HORIZONTAL,
				   uint32 resizeMask = B_FOLLOW_NONE);
	~DividerControl();
	
	virtual	void			AttachedToWindow();
	//virtual	void			AllAttached();
	virtual	void			DetachedFromWindow();
	//virtual	void			AllDetached();

	virtual	void			FrameMoved(BPoint new_position);
	virtual	void			MessageReceived(BMessage *msg);

	virtual	void			Draw(BRect updateRect);
	virtual	void			MouseDown(BPoint where);
	virtual	void			MouseUp(BPoint where);
	virtual	void			MouseMoved(	BPoint where,
										uint32 code,
										const BMessage *a_message);
	
	virtual	void			GetPreferredSize(float *width, float *height);
	
	virtual	void			SetValue(int32 value);
	void					AnimateValue(int32 value);
	
private:
	typedef BControl inherited;
	
	orientation fOrientation;
	bool fFillToEdge;
	
	// Tracking the movement bar.
	bool fTracking;
	BPoint fInitPoint;
	float fInitPos;
	rgb_color fBackColor;
	
	// Twisting the visibility knob.
	float TargetTwist() const;
	void StartTwisting();
	bool fTwisting;
	bool fOverKnob;
	float fTwistAmount;
	float fTwistSpeed;
	BMessageRunner* fTwistPulse;
};

};	// namespace BExperimental

using namespace BExperimental;

#endif
