/******************************************************************************
/
/	File:			UTF8.h
/
/	Description:	UTF-8 conversion functions.
/
/	Copyright 1993-98, Be Incorporated
/
******************************************************************************/


#ifndef _UTF8_H
#define _UTF8_H

#include <BeBuild.h>
#include <InterfaceDefs.h>
#include <SupportDefs.h>

/*------------------------------------------------------------*/
/*------- Conversion Flavors ---------------------------------*/
enum {
	B_ISO1_CONVERSION				=	0,				/* ISO 8859-1 */
	B_ISO2_CONVERSION				= 	1,				/* ISO 8859-2 */
	B_ISO3_CONVERSION				= 	2,				/* ISO 8859-3 */
	B_ISO4_CONVERSION				= 	3,				/* ISO 8859-4 */
	B_ISO5_CONVERSION				= 	4,				/* ISO 8859-5 */
	B_ISO6_CONVERSION				= 	5,				/* ISO 8859-6 */
	B_ISO7_CONVERSION				= 	6,				/* ISO 8859-7 */
	B_ISO8_CONVERSION				=	7,				/* ISO 8859-8 */
	B_ISO9_CONVERSION				=	8,				/* ISO 8859-9 */
	B_ISO10_CONVERSION				=	9,				/* ISO 8859-10 */
	B_MAC_ROMAN_CONVERSION			=	10,				/* Macintosh Roman */
	B_SJIS_CONVERSION				=	11,				/* Shift-JIS */
	B_EUC_CONVERSION				=	12,				/* EUC Packed Japanese */
	B_JIS_CONVERSION				=	13,				/* JIS X 0208-1990 */
	B_MS_WINDOWS_CONVERSION			=	14,				/* MS-Windows Codepage 1252 */
	B_UNICODE_CONVERSION			=	15,				/* Unicode 2.0 */
	B_KOI8R_CONVERSION				=	16,				/* KOI8-R */
	B_MS_WINDOWS_1251_CONVERSION	=	17,				/* MS-Windows Codepage 1251 */
	B_MS_DOS_866_CONVERSION			=	18,				/* MS-DOS Codepage 866 */
	B_MS_DOS_CONVERSION				=	19,				/* MS-DOS Codepage 437 */
	B_EUC_KR_CONVERSION				=	20,				/* EUC Korean */
	B_ISO13_CONVERSION				=	21,				/* ISO 8859-13 */
	B_ISO14_CONVERSION				=	22,				/* ISO 8859-14 */
	B_ISO15_CONVERSION				=	23,				/* ISO 8859-15 */
	B_BIG5_CONVERSION				=	24,				/* Big5 */
	B_GBK_CONVERSION				=	25				/* GBK */
};

/*-------------------------------------------------------------*/
/*------- Conversion Functions --------------------------------*/

_IMPEXP_TEXTENCODING status_t convert_to_utf8(uint32		srcEncoding, 
						 					  const char	*src, 
						 					  int32			*srcLen, 
											  char			*dst, 
						 					  int32			*dstLen,
											  int32			*state,
											  char			substitute = B_SUBSTITUTE);

_IMPEXP_TEXTENCODING status_t convert_from_utf8(uint32		dstEncoding,
												const char	*src, 
												int32		*srcLen, 
						  						char		*dst, 
						   						int32		*dstLen,
												int32		*state,
												char		substitute = B_SUBSTITUTE);

/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/

#endif	/* _UTF8_H */
